## ros-indigo-kni 1.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(kni)

add_compile_options(-std=c++11)

find_package(catkin REQUIRED)

find_package(Boost REQUIRED)

catkin_package(
  INCLUDE_DIRS KNI_4.3.0/include
  LIBRARIES KNIBase Kinematics KNI_InvKin KNI_LM
  CATKIN_DEPENDS
  DEPENDS Boost
)

include_directories(KNI_4.3.0/include ${Boost_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS})

# knicommon
aux_source_directory(KNI_4.3.0/src/common/ knicommon_SOURCES)
add_library(knicommon STATIC ${knicommon_SOURCES})

# KNIBase
aux_source_directory(KNI_4.3.0/src/Base/ KNIBase_SOURCES)
add_library(KNIBase SHARED ${KNIBase_SOURCES})
target_link_libraries(KNIBase knicommon)

# roboop
aux_source_directory(KNI_4.3.0/lib/kinematics/roboop/source/ roboop_SOURCES)
aux_source_directory(KNI_4.3.0/lib/kinematics/roboop/newmat/ roboop_SOURCES)
include_directories(include KNI_4.3.0/lib/kinematics/roboop/newmat/)
add_library(roboop STATIC ${roboop_SOURCES})

# Kinematics
aux_source_directory(KNI_4.3.0/lib/kinematics/ Kinematics_SOURCES)
aux_source_directory(KNI_4.3.0/lib/kinematics/AnalyticalGuess/src/ Kinematics_SOURCES)
include_directories(include KNI_4.3.0/lib/kinematics/AnalyticalGuess/include/)
add_library(Kinematics SHARED ${Kinematics_SOURCES})
target_link_libraries(Kinematics roboop)

# KNI_InvKin
aux_source_directory(KNI_4.3.0/src/InvKin/ KNI_InvKin_SOURCES)
add_library(KNI_InvKin SHARED ${KNI_InvKin_SOURCES})
target_link_libraries(KNI_InvKin Kinematics)

# KNI_LM
aux_source_directory(KNI_4.3.0/src/LM/ KNI_LM_SOURCES)
add_library(KNI_LM SHARED ${KNI_LM_SOURCES})
target_link_libraries(KNI_LM knicommon KNIBase)

set_target_properties(knicommon KNIBase roboop Kinematics KNI_InvKin KNI_LM 
  PROPERTIES COMPILE_FLAGS "-fPIC")

install(TARGETS KNIBase Kinematics KNI_InvKin KNI_LM
  DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(DIRECTORY KNI_4.3.0/include/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION})

install(DIRECTORY KNI_4.3.0/configfiles300
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/KNI_4.3.0/)

install(DIRECTORY KNI_4.3.0/configfiles400
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/KNI_4.3.0/)

install(DIRECTORY KNI_4.3.0/configfiles450
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/KNI_4.3.0/)

=== KNI_4.3.0/Makefile ===
#===========================================================================
# KNI root Makefile
# copyright Neuronics Switzerland 2005-2009
# Authors: see AUTHORS file
#===========================================================================

TARGETS			=	lib/kinematics src/common src/Base src/InvKin src/LM src/kni_wrapper py demo
TARGETS_B		=	$(foreach target,$(TARGETS),$(target).build)
TARGETS_C		=	$(foreach target,$(TARGETS),$(target).clean)
NEURONICS_DOC_DIR	=	doc/neuronics-doc/source

.SILENT:

.PHONY: all doc

all:
	$(MAKE) $(TARGETS_B)

clean:
	$(MAKE) $(TARGETS_C)

$(TARGETS_B):
	echo ""
	echo "==========================================================="
	echo "---  $(@)"
	echo "-----------------------------------------------------------"
	$(MAKE) -C $(@:.build=)
	echo "==========================================================="

$(TARGETS_C):
	echo ""
	echo "==========================================================="
	echo "---  $(@)"
	echo "-----------------------------------------------------------"
	$(MAKE)	-C $(@:.clean=) clean

doc.clean:
	echo ""
	echo "==========================================================="
	echo "---  $(@)"
	echo "-----------------------------------------------------------"
	rm -Rf ./doc/html
	rm -Rf ./doc/rtf
	rm -Rf ./doc/latex
	$(MAKE) -C $(NEURONICS_DOC_DIR) clean

doc:	
	echo ""
	echo "==========================================================="
	echo "---  $(@)"
	echo "-----------------------------------------------------------"
	doxygen	Doxyfile

doc-neuronics: doc 
	ln -sf $(PWD)/doc/latex/*.tex  $(PWD)/$(NEURONICS_DOC_DIR)  
	ln -sf $(PWD)/doc/latex/*.pdf  $(PWD)/$(NEURONICS_DOC_DIR)
	ln -sf $(PWD)/doc/latex/*.eps  $(PWD)/$(NEURONICS_DOC_DIR)
	cd $(NEURONICS_DOC_DIR); ./trunkfile.py
	$(MAKE) -C $(NEURONICS_DOC_DIR) install

doc-neuronics-deploy: doc-neuronics
	$(MAKE) -C $(NEURONICS_DOC_DIR) deploy

=== KNI_4.3.0/demo/Makefile ===
#===========================================================================
# KNI demo Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-g -O2 -Wall

TARGETS		=	kni_test control commands kni_wrapper wrapper_control mykni
CTARGETS	=	keyboard

TARGETS_D	=	$(foreach target,$(TARGETS),$(target).demo)
TARGETS_D_C	=	$(foreach target,$(TARGETS),$(target).demo_clean)

CTARGETS_D	=	$(foreach target,$(CTARGETS),$(target).common)

INCLUDE_DIR = ../include -I./common
LIBRARY_DIR  = ../lib/linux

BASE_LIBRARY = $(LIBRARY_DIR)/libKNIBase.a
KINE_LIBRARY = $(LIBRARY_DIR)/libKinematics.a
INVKIN_LIBRARY = $(LIBRARY_DIR)/libKNI_InvKin.a
LM_LIBRARY = $(LIBRARY_DIR)/libKNI_LM.a
WRAPPER_LIBRARY = $(LIBRARY_DIR)/kni.a

AVAILABLE_LIBRARIES = ./common/keyboard.o  ${WRAPPER_LIBRARY} ${LM_LIBRARY} ${INVKIN_LIBRARY} ${KINE_LIBRARY} ${BASE_LIBRARY} 

#.SILENT:

all: $(TARGETS_D)

$(CTARGETS_D):
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c -o common/$(@:.common=).o $(wildcard common/$(@:.common=).cpp)
	

$(TARGETS_D): $(CTARGETS_D)
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -lpthread -o $(@:.demo=)/$(@:.demo=) $(wildcard $(@:.demo=)/*.cpp) ${AVAILABLE_LIBRARIES}
	

$(TARGETS_D_C):
	echo "Cleaning: $(@:_clean=)"
	rm -f $(@:.demo_clean=)/$(@:.demo_clean=)
	rm -f $(@:.demo_clean=)/*~
	rm -f $(@:.demo_clean=)/*.o

clean_common:
	echo "Cleaning: common"
	rm -f common/*.o
	rm -f common/*~

clean: clean_common $(TARGETS_D_C)
	echo "Cleaning up"
	rm -f ./.?log

=== KNI_4.3.0/py/Makefile ===
#===========================================================================
# KNI Python interface Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================
PYTHON_INCLUDE = /usr/include/python2.6

KNI_INCLUDE   = ../include
KNI_LIBPATH   =	../lib/linux
KNI_LIBRARIES = $(KNI_LIBPATH)/kni.a $(KNI_LIBPATH)/libKNIBase.a $(KNI_LIBPATH)/libKNI_InvKin.a $(KNI_LIBPATH)/libKNI_LM.a $(KNI_LIBPATH)/kni.a $(KNI_LIBPATH)/libKinematics.a

CXXFLAGS        +=      -ggdb -fPIC

all: _KNI_noswig

rebuild: _KNI

KNI_wrap.cxx: KNI.i
	swig -c++ -python KNI.i


_KNI_noswig:
	echo "Building: KNI Python wrapper"
	$(CXX) $(CXXFLAGS) -c -I $(PYTHON_INCLUDE) -I $(KNI_INCLUDE) KNI_wrap.cxx
	$(CXX) $(CXXFLAGS) -shared *.o -o _KNI.so $(KNI_LIBRARIES)
	
_KNI: KNI_wrap.cxx
	echo "Building: KNI Python wrapper with SWIG"
	$(CXX) $(CXXFLAGS) -c -I $(PYTHON_INCLUDE) -I $(KNI_INCLUDE) KNI_wrap.cxx
	$(CXX) $(CXXFLAGS) -shared *.o -o $@.so $(KNI_LIBRARIES)

clean:
	rm -f *.so *.o *~ *.pyc *.zip 

#===========================================================================

=== KNI_4.3.0/lib/kinematics/Makefile ===
#===========================================================================
# Kinematics Makefile
# (C) Neuronics AG
# Jonas Haller 2009
#===========================================================================
CXX			=	g++
CXXFLAGS	+=	-c -Wall -D_REENTRANT -D__NO_MATH_INLINES -pthread  -I $(BOOST_INCLUDE_DIR) -fPIC
LD			=	g++
LDFLAGS		=	-shared -fPIC
MAKE		=	make

SUBDIRS		=	AnalyticalGuess roboop

TARGET_LIB_SO 	= 	libKinematics.so
TARGET_LIB_A	=	libKinematics.a
OUTPUT_DIR		=	../linux

BOOST_INCLUDE_DIR	=	/usr/include

KINEMATICS_LIBDIRS	=	-L./roboop -L./AnalyticalGuess/lib 
UTIL_LIBS		=	-lm -lpthread
KIN_LIBFILES	=	-lroboop -lnewmat -lAnalyticalGuess

KIN_LIBS		=	roboop/libnewmat.a roboop/libroboop.a AnalyticalGuess/lib/libAnalyticalGuess.a

INCDIR			=	.
KIN_INCDIR		=	./roboop/source
MATH_INCDIR		=	./roboop/newmat
AG_INCDIR		=	./AnalyticalGuess/include

KINLIB_SOURCES 	= 	kinematics.cpp libKinematics.cpp


.SILENT:
all: build
build: subdirs $(TARGET_LIB_SO) $(TARGET_LIB_A)

%.o: %.cpp
	echo ""
	echo "=================================="
	echo "Compiling: $@ ..."
	$(CXX) $(CXXFLAGS) -I $(INCDIR) -I $(KIN_INCDIR) -I $(MATH_INCDIR) -I $(AG_INCDIR) $< 
	echo "... done"
	echo "=================================="
	echo ""

$(TARGET_LIB_SO): $(KINLIB_SOURCES:.cpp=.o)
	echo ""
	echo "=================================="
	echo "Building: $@ ..."
	$(LD) $(LDFLAGS) -o $(OUTPUT_DIR)/$@ $(KINLIB_SOURCES:.cpp=.o) $(UTIL_LIBS) $(KINEMATICS_LIBDIRS) $(KIN_LIBFILES)
	echo "... done"
	echo "=================================="
	echo ""

$(TARGET_LIB_A): $(KINLIB_SOURCES:.cpp=.o)
	echo "=================================="
	echo -n "Building: $@ ...\n"
	$(AR) $(ARFLAGS) $@ $(KINLIB_SOURCES:.cpp=.o)
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	for arfile in $(KIN_LIBS) ; do \
		$(AR) x ../$$arfile; \
		$(AR) q ../$@ *; \
		rm *; \
	done
	@cd ..
	@rm -r .ar_tmp
	ranlib $@
	mv $@ $(OUTPUT_DIR)/$@
	echo "... done"
	echo "=================================="

############################################################################
subdirs:
	@for i in $(SUBDIRS); do \
	echo "make all in $$i..."; \
	(cd $$i; $(MAKE)); done
############################################################################
clean:
	echo ""
	echo "=================================="
	echo "cleaning up ...:"
	@for i in $(SUBDIRS); do \
	echo "make clean in $$i..."; \
	(cd $$i; $(MAKE) $(MFLAGS) clean); \
	echo "...done"; done
	rm -rf *.o *~ $(OUTPUT_DIR)/$(TARGET_LIB_SO) $(OUTPUT_DIR)/$(TARGET_LIB_A) 2>/dev/null
	echo "... done cleaning up"
	echo "=================================="
	echo ""
############################################################################

=== KNI_4.3.0/src/Base/Makefile ===
#===========================================================================
# KNI base Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-fPIC -g -O2 -Wall

TARGETS		=	alib solib

LIBNAME = libKNIBase
SOURCES = cdlCOM.cpp cplSerial.cpp cdlSocket.cpp CRC.cpp kmlBase.cpp kmlExt.cpp kmlMotBase.cpp kmlSctBase.cpp kmlFactories.cpp

ADDITIONAL_DEPS = ../common/Timer.o

LIBNAME_A  = $(LIBNAME).a
LIBNAME_SO = $(LIBNAME).so

SLCFLAGS=-fPIC
SLLDFLAGS=-shared

INCLUDE_DIR = ../../include
TARGET_DIR  = ../../lib/linux

.SILENT:

.SUFFIXES: .cpp.o

.cpp.o:
	echo "Compiling: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c $<

all: $(TARGETS)

$(TARGET_DIR)/$(LIBNAME_A): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(AR) $(ARFLAGS) $@ $(SOURCES:.cpp=.o) > /dev/null
	echo "Adding common/additional dependencies..."
	$(AR) -r $@ $(ADDITIONAL_DEPS) > /dev/null
	
$(TARGET_DIR)/$(LIBNAME_SO): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) $(SLLDFLAGS) -o $@ $(SOURCES:.cpp=.o) $(ADDITIONAL_DEPS)

alib: $(TARGET_DIR)/$(LIBNAME_A)

solib: $(TARGET_DIR)/$(LIBNAME_SO)

clean:
	echo "Cleaning up"
	rm -rf *.o *~ $(TARGET_DIR)/$(LIBNAME_A) $(TARGET_DIR)/$(LIBNAME_SO)

=== KNI_4.3.0/src/InvKin/Makefile ===
#===========================================================================
# KNI Invers Kinematics Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-fPIC -g -O2 -Wall

TARGETS		=	alib solib

LIBNAME = libKNI_InvKin
SOURCES = ikBase.cpp KatanaKinematics6M90G.cpp KatanaKinematics6M90T.cpp KatanaKinematics6M180.cpp KatanaKinematics5M180.cpp KatanaKinematicsDecisionAlgorithms.cpp

ADDITIONAL_DEPS = ../common/Timer.o

LIBNAME_A  = $(LIBNAME).a
LIBNAME_SO = $(LIBNAME).so

SLCFLAGS=-fPIC
SLLDFLAGS=-shared

INCLUDE_DIR = ../../include
TARGET_DIR  = ../../lib/linux

.SILENT:

.SUFFIXES: .cpp.o

.cpp.o:
	echo "Compiling: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c $< 

all: $(TARGETS)

$(TARGET_DIR)/$(LIBNAME_A): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(AR) $(ARFLAGS) $@ $(SOURCES:.cpp=.o) > /dev/null
	echo "Adding common/additional dependencies..."	
	$(AR) -r $@ $(ADDITIONAL_DEPS) > /dev/null

$(TARGET_DIR)/$(LIBNAME_SO): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) $(SLLDFLAGS) -o $@ $(SOURCES:.cpp=.o) $(ADDITITIONAL_DEPS) -L../../lib/linux -lKinematics -lKNIBase

alib: $(TARGET_DIR)/$(LIBNAME_A)

solib: $(TARGET_DIR)/$(LIBNAME_SO)

clean:	
	echo "Cleaning up"
	rm -rf *.o *~ $(TARGET_DIR)/$(LIBNAME_A) $(TARGET_DIR)/$(LIBNAME_SO)

=== KNI_4.3.0/src/LM/Makefile ===
#===========================================================================
# KNI Linear Motion Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-fPIC -g -O2 -Wall

TARGETS		=	alib solib

LIBNAME = libKNI_LM
SOURCES = lmBase.cpp

ADDITIONAL_DEPS = ../common/Timer.o

LIBNAME_A  = $(LIBNAME).a
LIBNAME_SO = $(LIBNAME).so

SLCFLAGS=-fPIC
SLLDFLAGS=-shared

INCLUDE_DIR = ../../include
TARGET_DIR  = ../../lib/linux

.SILENT:

.SUFFIXES: .cpp.o

.cpp.o:
	echo "Compiling: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c $< 

all: $(TARGETS)

$(TARGET_DIR)/$(LIBNAME_A): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(AR) $(ARFLAGS) $@ $(SOURCES:.cpp=.o) > /dev/null
	echo "Adding common/additional dependencies..."	
	$(AR) -r $@ $(ADDITIONAL_DEPS) > /dev/null

$(TARGET_DIR)/$(LIBNAME_SO): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) $(SLLDFLAGS) -o $@ $(SOURCES:.cpp=.o) $(ADDITITIONAL_DEPS) -L../../lib/linux -lKNIBase

alib: $(TARGET_DIR)/$(LIBNAME_A)

solib: $(TARGET_DIR)/$(LIBNAME_SO)

clean:	
	echo "Cleaning up"
	rm -rf *.o *~ $(TARGET_DIR)/$(LIBNAME_A) $(TARGET_DIR)/$(LIBNAME_SO)

=== KNI_4.3.0/src/common/Makefile ===
#===========================================================================
# KNI common Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-g -O2 -Wall -fPIC

TARGETS		=	alib

LIBNAME = knicommon
SOURCES = Timer.cpp

LIBNAME_A  = $(LIBNAME).a

INCLUDE_DIR = ../../include
TARGET_DIR  = .

.SILENT:

.SUFFIXES: .cpp.o

.cpp.o:
	echo "Compiling: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c $< 
	

all: $(TARGETS)

$(TARGET_DIR)/$(LIBNAME_A): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(AR) $(ARFLAGS) $@ $(SOURCES:.cpp=.o) > /dev/null
	

alib: $(TARGET_DIR)/$(LIBNAME_A)


clean:	
	echo "Cleaning up"
	rm -rf *.o *~  $(TARGET_DIR)/$(LIBNAME_A)

=== KNI_4.3.0/src/kni_wrapper/Makefile ===
#===========================================================================
# KNI C wrapper Makefile
# copyright Neuronics Switzerland 2005-2008
# Authors: see AUTHORS file in the KNI root directory 
#===========================================================================

CXX		=	g++
CXXFLAGS	+=	-fPIC -g -O2 -Wall

TARGETS		=	alib solib

LIBNAME = kni
SOURCES = kni_wrapper.cpp

ADDITIONAL_DEPS = ../common/Timer.o

LIBNAME_A  = $(LIBNAME).a
LIBNAME_SO = $(LIBNAME).so

SLCFLAGS=-fPIC
SLLDFLAGS=-shared

INCLUDE_DIR = ../../include
TARGET_DIR  = ../../lib/linux

.SILENT:

.SUFFIXES: .cpp.o

.cpp.o:
	echo "Compiling: $@"
	$(CXX) $(CXXFLAGS) -I$(INCLUDE_DIR) -c $< 

all: $(TARGETS)

$(TARGET_DIR)/$(LIBNAME_A): $(SOURCES:.cpp=.o)
	echo "Building: $@ "
	$(AR) $(ARFLAGS) $@ $(SOURCES:.cpp=.o) > /dev/null
	echo "Adding common/additional dependencies..."	
	$(AR) -r $@ $(ADDITIONAL_DEPS) > /dev/null

$(TARGET_DIR)/$(LIBNAME_SO): $(SOURCES:.cpp=.o)
	echo "Building: $@"
	$(CXX) $(CXXFLAGS) $(SLLDFLAGS) -o $@ $(SOURCES:.cpp=.o) $(ADDITITIONAL_DEPS)

alib: $(TARGET_DIR)/$(LIBNAME_A)

solib: $(TARGET_DIR)/$(LIBNAME_SO)

clean:	
	echo "Cleaning up"
	rm -rf *.o *~ $(TARGET_DIR)/$(LIBNAME_A) $(TARGET_DIR)/$(LIBNAME_SO)

=== KNI_4.3.0/doc/neuronics-doc/source/Makefile ===
# -----------------------------------------------------------------------------
# Makefile for the generation of a pdf dokument files from latex files
#
# Usage: place your dot files with this Makefile into a directory
#        and execute "make".
#
# by Lukas Burger, Thomas Popp, 2003 - 2007
# -----------------------------------------------------------------------------
TARGET = manual

# spelling options
ASPELLLANG   := --lang=de
ASPELLPWS    := -p aspell-WordList.pws
ASPELLPREPL  := --repl aspell--ReplaceList.prepl
ASPELLOPT    := --add-tex-command="hypersetup p,lstset p,fancyhead oo,bibliographystyle p,PassOptionsToPackage pp,pdfinfo p,todo p"

# installing options (getting document name from latex files)
INSTALL	:= ..
DOCNUM  := $(shell cat $(TARGET).tex | grep \\myDocnum | sed 's/.*{\(.*\)}.*/\1/')
VERSION := $(shell cat $(TARGET).tex | grep \\myVersion | sed 's/.*{\(.*\)}.*/\1/')
TITLE	:= $(shell cat $(TARGET).tex | grep \\myTitle | sed 's/.*{\(.*\)}.*/\1/' | sed 's/ /_/g' | sed 's/\,/_/g')
SUBTITLE := $(shell cat $(TARGET).tex | grep \\mySubTitle | sed 's/.*{\(.*\)}.*/\1/' | sed 's/ /_/g' | sed 's/\,/_/g')
PRODUCT  := $(shell cat $(TARGET).tex | grep \\myProduct | sed 's/.*{\(.*\)}.*/\1/' | sed 's/ /_/g' | sed 's/\,/_/g')

ifeq ($(DOCNUM),)
  SEP =
else
  SEP = -
endif

DOCNAME := $(INSTALL)/$(DOCNUM)$(SEP)$(PRODUCT)-$(TITLE)-$(SUBTITLE)-v$(VERSION).pdf

TEXFILES := $(wildcard *.tex)

AUTOIMAGEDIRS := tgif dia octave dot

ifeq ($(V),1)
  Q     =
  QECHO = @\#
else
  Q     = @
  QECHO = @echo
endif

all: $(TARGET).pdf

new:
	rm -f $(TARGET).pdf

install: all
	cp $(TARGET).pdf $(DOCNAME)

deploy: install
	$(MAKE) distclean
	svn add $(DOCNAME)
	svn commit . $(DOCNAME) -m "adding document $(DOCNUM) $(TITLE) v$(VERSION)"

auto-images:
	$(Q) for i in $(AUTOIMAGEDIRS); do \
	       if [ -d $$i ]; then \
	         $(MAKE) -C $$i; \
	       fi; \
	     done

# PDF
${TARGET}.pdf: $(TEXFILES) auto-images
	echo "Running latex..."
	pdflatex ${TARGET}.tex
	if [ -f bibliography.tex ]; then \
	    echo "Running bibtex..."; \
	    bibtex ${TARGET}; \
	fi
	echo "Rerunning latex...."
	pdflatex ${TARGET}.tex
	latex_count=5 ; \
	while egrep -s 'Rerun (LaTeX|to get cross-references right)' ${TARGET}.log && [ $$latex_count -gt 0 ] ;\
	    do \
	      echo "Rerunning latex...." ;\
	      pdflatex ${TARGET}.tex ;\
	      latex_count=`expr $$latex_count - 1` ;\
	    done

# spell checker
spell:  $(subst .tex,.tex.bak,$(wildcard *.tex))

# spell checker rule
%.tex.bak: %.tex
	aspell --mode=tex $(ASPELLLANG) $(ASPELLPWS) $(ASPELLPREPL) $(ASPELLOPT) check $<

# garbage collectors
.PHONY:	clean cleanimages distclean mrproper
clean:
	$(QECHO) -n "Cleaning up. "
	$(Q) rm -f *~ *.tex.bak *.tex.backup *.aux *.log *.out *.blg *.bbl *.brf *.toc *.lof *.lot *.dvi report.pdf
	$(QECHO) "[ok]"
	$(Q) rm `find . -type l`
	$(Q) rm filelist.tex

cleanimages:
	$(Q) for i in $(AUTOIMAGEDIRS); do \
	       if [ -d $$i ]; then \
	         $(MAKE) -C $$i clean; \
	       fi \
	     done

distclean:	clean cleanimages

mrproper: distclean
	rm -f $(TARGET).pdf

=== KNI_4.3.0/lib/kinematics/AnalyticalGuess/Makefile ===
#===========================================================================
# AnalyticalGuess
# Root Makefile
# copyright: Neuronics AG, Switzerland, 2008
# Author: Jonas Haller 05/2008
#===========================================================================


TARGETS			=	src
TARGETS_B		=	$(foreach target,$(TARGETS),$(target).build)
TARGETS_C		=	$(foreach target,$(TARGETS),$(target).clean)

.SILENT:

.PHONY: all doc

all:
	$(MAKE) $(TARGETS_B)

clean:
	$(MAKE) $(TARGETS_C)

cross: 
	$(MAKE) CXX=/opt/eldk/usr/bin/ppc_6xx-g++ LD=/opt/eldk/usr/bin/ppc_6xx-g++

$(TARGETS_B):
	echo ""
	echo "___________________________________________________________"
	echo "$(@)"
	echo "___________________________________________________________"
	$(MAKE) -C $(@:.build=)
	echo ""

$(TARGETS_C):
	echo ""
	echo "___________________________________________________________"
	echo "$(@)"
	echo "___________________________________________________________"
	$(MAKE)	-C $(@:.clean=) clean

doc.clean:
	echo ""
	echo "___________________________________________________________"
	echo "$(@)"
	echo "___________________________________________________________"
	rm -Rf ./doc/html

doc:
	echo ""
	echo "___________________________________________________________"
	echo "$(@)"
	echo "___________________________________________________________"
	doxygen	Doxyfile

=== debian/changelog ===
ros-indigo-kni (1.1.2-0trusty) trusty; urgency=high

  * kni: Build with c++11, fix warnings
  * Contributors: Martin Günther

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Thu, 01 Jun 2017 22:00:00 -0000

ros-indigo-kni (1.1.1-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Thu, 25 May 2017 22:00:00 -0000

ros-indigo-kni (1.1.0-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Thu, 25 May 2017 22:00:00 -0000

ros-indigo-kni (1.0.8-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Thu, 25 May 2017 22:00:00 -0000

ros-indigo-kni (1.0.7-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Fri, 10 Feb 2017 23:00:00 -0000

ros-indigo-kni (1.0.6-0trusty) trusty; urgency=high

  * Fix deprecation warning (#20 <https://github.com/uos/katana_driver/issues/20>)
  * Initial release to Kinetic
  * Contributors: Martin Günther

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Thu, 26 Jan 2017 23:00:00 -0000

ros-indigo-kni (1.0.5-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Mon, 11 Apr 2016 22:00:00 -0000

ros-indigo-kni (1.0.4-0trusty) trusty; urgency=high



 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Sun, 10 Apr 2016 22:00:00 -0000

ros-indigo-kni (1.0.3-0trusty) trusty; urgency=high

  * Removed external project handling scheme from CMakeLists.txt.
    The kni package's catkin definitions now do not rely on the original
    project's Makefiles anymore. It now directly handles the build process.
    This has the advantage that resulting targets are no "meta" targets
    anymore. This caused client applications to link against the absolute
    library path from build time, not using the library name + path pattern.
  * Contributors: Leon Ziegler

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Sun, 28 Jun 2015 22:00:00 -0000

ros-indigo-kni (1.0.2-0trusty) trusty; urgency=high

  * Even more KNI dependencies
  * Contributors: Jochen Sprickerhof

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Tue, 05 May 2015 22:00:00 -0000

ros-indigo-kni (1.0.1-0trusty) trusty; urgency=high

  * kni: add missing boost dependency in package.xml
  * Contributors: Martin Günther

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Mon, 16 Mar 2015 23:00:00 -0000

ros-indigo-kni (1.0.0-0trusty) trusty; urgency=high

  * Initial release to Debian packages
  * Contributors: Martin Günther, Henning Deeken, Jochen Sprickerhof, Michael Görner

 -- Martin Günther <mguenthe@uni-osnabrueck.de>  Sun, 15 Mar 2015 23:00:00 -0000

=== debian/control ===
Source: ros-indigo-kni
Section: misc
Priority: extra
Maintainer: Martin Günther <mguenthe@uni-osnabrueck.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-indigo-catkin
Homepage: http://ros.org/wiki/kni
Standards-Version: 3.9.2

Package: ros-indigo-kni
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev
Description: This package provides the third-party KNI (Katana Native Interface) library for Katana robot arms.
 Instead of using the KNI library directly, the katana package should be used for communication with the Katana arm.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-kni//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
